#include <stdint.h>
#include <stdlib.h>
#include "util.h"

int bit_count(uint32_t A)
{
  int i,j;
  unsigned int mask[5]=
  {
    0x55555555,
    0x33333333,
    0x0f0f0f0f,
    0x00ff00ff,
    0x0000ffff
  };
  for(i=0,j=1;i<5;i++,j<<=1)
    A= (A&mask[i]) + ((A>>j)&mask[i]);
  return A;
}

int highest_bit(uint32_t A)
{
  uint32_t i;
  for(i=1;i<32;i<<=1) A |= (A>>i);
  return (bit_count(A)+32)%33;    
}

int lowest_bit(uint32_t A)
{
  uint32_t i;
  for(i=1;i<32;i<<=1) A |= (A<<i);
  return bit_count(~A);
}

int imax2(int a,int b)
{
  return a>b?a:b;
}
int imin2(int a,int b)
{
  return a<b?a:b;
}


